package com.zanxiang.game.module.manage.controller.api;

import com.zanxiang.game.module.manage.service.ISmsService;
import com.zanxiang.module.util.pojo.ResultVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author : lingfeng
 * @time : 2024-11-04
 * @description : 手机短信接口
 */
@Slf4j
@Api(tags = {"手机短信接口"})
@RestController
@RequestMapping("/api/sms")
public class SmsController {

    @Autowired
    private ISmsService smsService;

    @ApiOperation(value = "手机验证码发送")
    @GetMapping(value = "/random/code/send")
    @ApiResponses(value = {@ApiResponse(code = 200, message = "成功", response = Boolean.class)})
    public ResultVO<Boolean> randomCodeSend(@RequestParam String phoneNumber) {
        return ResultVO.ok(smsService.randomCodeSend(phoneNumber));
    }
}
