package com.zanxiang.game.module.manage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.module.manage.pojo.params.GameGiftPackCodeLogListParam;
import com.zanxiang.game.module.manage.pojo.vo.GameGiftPackCodeLogVO;
import com.zanxiang.game.module.manage.service.IGameGiftPackCodeLogService;
import com.zanxiang.game.module.manage.service.IGameUserRoleService;
import com.zanxiang.game.module.mybatis.entity.GameGiftPackCodeLog;
import com.zanxiang.game.module.mybatis.mapper.GameGiftPackCodeLogMapper;
import com.zanxiang.module.util.bean.BeanUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.util.function.Tuple2;

import java.time.LocalDateTime;
import java.time.LocalTime;

/**
 * @author : lingfeng
 * @time : 2022-06-22
 * @description : 游戏礼包码领取日志
 */
@Service
public class GameGiftPackCodeLogServiceImpl extends ServiceImpl<GameGiftPackCodeLogMapper, GameGiftPackCodeLog> implements IGameGiftPackCodeLogService {

    @Autowired
    private IGameUserRoleService gameUserRoleService;

    @Override
    public IPage<GameGiftPackCodeLogVO> list(GameGiftPackCodeLogListParam param) {
        return page(param.toPage(), new QueryWrapper<GameGiftPackCodeLog>().lambda()
                .eq(GameGiftPackCodeLog::getLinkId, param.getLinkId())
                .ge(param.getCreateBeginTime() != null, GameGiftPackCodeLog::getCreateTime, param.getCreateBeginTime() == null ? null : LocalDateTime.of(param.getCreateBeginTime(), LocalTime.MIN))
                .le(param.getCreateEndTime() != null, GameGiftPackCodeLog::getCreateTime, param.getCreateEndTime() == null ? null : LocalDateTime.of(param.getCreateEndTime(), LocalTime.MAX))
                .orderByDesc(GameGiftPackCodeLog::getCreateTime)
        ).convert(log -> BeanUtil.copy(log, GameGiftPackCodeLogVO.class));
    }

    public Tuple2<Boolean, String> gameRoleCheck(String gameServerId, String roleName) {
        return null;
    }
}